(module vigraplt scheme
  (provide 
           ;path
           vigraplt-path
           ;version
           vigraplt-version
           
           ;vigraplt.helpers:
           
           ;bands
           make-band
           band-data
           band-width
           band-height
           band-ref
           band-set!
           copy-band
           band->image
           band->matrix
           band->list
           list->band
           band-map
           band-map!
           band-for-each-index
           band-reduce
           
           ;images
           make-image
           image-band
           image-data
           image-width
           image-height
           image-numbands
           image-ref
           image-set!
           copy-image
           image->red-band
           image->red
           image->green-band
           image->green
           image->blue-band
           image->blue
           image->list
           list->image
           image-map
           image-map!
           image-for-each-index
           image-reduce
           
           ;matrices
           make-matrix
           matrix-data
           matrix-rows
           matrix-cols
           matrix-ref
           matrix-set!
           copy-matrix
           matrix->list
           list->matrix
           matrix-mult
           
           ;vigraplt.impex
           loadimage
           saveimage
           
           ;;vigraplt.filters
           convolveimage-band
           convolveimage
           separableconvolveimage-band
           separableconvolveimage
           gsmooth-band
           gsmooth
           gaussiangradient-band
           gaussiangradient
           ggradient-band
           ggradient
           laplacianofgaussian-band
           laplacianofgaussian
           hessianmatrixofgaussian-band
           hessianmatrixofgaussian
           structuretensor-band
           structuretensor
           boundarytensor-band
           boundarytensor
           boundarytensor1-band
           boundarytensor1
           tensoreigenrepresentation-band
           tensoreigenrepresentation
           tensortrace-band
           tensortrace
           tensortoedgecorner-band
           tensortoedgecorner
           hourglassfilter-band
           hourglassfilter
           gsharpening-band
           gsharpening
           sharpening-band
           sharpening
           nonlineardiffusion-band
           nonlineardiffusion
           distancetransform-band
           distancetransform
           
           ;;vigraplt.imgproc
           resizeimage-band
           resizeimage
           rotateimage-band
           rotateimage
           affinewarpimage-band
           affinewarpimage
           reflectimage-band
           reflectimage
           fouriertransform-band
           fouriertransform
           
           ;;vigraplt.segmentation
           labelimage-band
           labelimage
           watersheds-band
           watersheds
           cannyedgeimage-band
           cannyedgeimage
           differenceofexponentialedgeimage-band
           differenceofexponentialedgeimage
           regionimagetocrackedgeimage-band
           regionimagetocrackedgeimage
           
           ;;vigraplt.morphology
           erodeimage-band
           erodeimage
           dilateimage-band
           dilateimage
           openingimage-band
           openingimage
           closingimage-band
           closingimage
           
           ;vigraplt.viewer
           show-image
  ) ; End of "provide"
  
 
  (require scheme/foreign)
  (unsafe!)

  (define vigraplt-path (collection-path "vigraplt"))
  (define vigraplt-version "0.5.0")

  ;Load dll under windows, dylib under MacOS
  (define dylib-path
    (cond ((equal? (system-type 'os) 'windows) (build-path vigraplt-path "vigra_c.dll"))
          ((equal? (system-type 'os) 'macosx)  (build-path vigraplt-path "libvigra_c.dylib"))
          ((equal? (system-type 'os) 'unix)  (build-path vigraplt-path "libvigra_c.so"))
          (else (error "Only macosx, windows and unix are supported"))))
    	    

  (include "vigraplt.carray.ss")
  (include "vigraplt.helpers.ss")
  (include "vigraplt.impex.ss")
  (include "vigraplt.filters.ss")
  (include "vigraplt.imgproc.ss")
  (include "vigraplt.segmentation.ss")
  (include "vigraplt.morphology.ss")
  (include "vigraplt.viewer.ss")

)

